﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.WinForms;
using ThinkGeo.MapSuite;
using System.Diagnostics;

namespace RenameOb
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            RectangleShape rect = new RectangleShape(new PointShape(0, 500), new PointShape(500, 0));

            LayerOverlay lo = new LayerOverlay();

            // Original Layer
            InMemoryFeatureLayer imfl = new InMemoryFeatureLayer();
            imfl.Name = "B1";
            imfl.InternalFeatures.Add(new Feature(rect));
            lo.Layers.Add("B1", imfl);

            // Buffer Original
            MultipolygonShape B1Buff = rect.Buffer(500, GeographyUnit.Meter, DistanceUnit.Meter);

            InMemoryFeatureLayer imflB = new InMemoryFeatureLayer();
            imflB.Name = "B1Buff";
            imflB.InternalFeatures.Add(new Feature(B1Buff));
            lo.Layers.Add("B1Buff", imflB);

            // Rename buffered layer
            Layer f = lo.Layers["B1Buff"];
            f.Name = "B1BuffRN";

            // Look at all the layer names to make sure the name was updated
            foreach (var layer in lo.Layers)
            {
                Debug.Print(layer.Name);
            }

            // Create a different buffer
            MultipolygonShape B2Buff = rect.Buffer(700, GeographyUnit.Meter, DistanceUnit.Meter);

            // Add it to the overlay using the original name of the 1st buffered layer
            InMemoryFeatureLayer imflB2 = new InMemoryFeatureLayer();
            imflB2.Name = "B1Buff";
            imflB2.InternalFeatures.Add(new Feature(B2Buff));
            lo.Layers.Add("B1Buff", imflB2);    // Item already exists!


        }
    }
}
